local names = {}

names.prefixes = {
    "Hacker",
    "Hacker's",
    "Slaughter",
    "Broken",
    "Trench",
    "Golden",
    "Silver",
    "Blue",
    "Red",
    "Fresh",
    "New",
    "Cold",
    "Hot",
    "Flaming",
    "Stinking",
    "Death",
    "Light",
    "Fire",
    "Cold",
    "Savvy",
    "Wreching",
    "Wrecking",
    "Death's",
    "Man's",
    "Slothful",
    "Gray",
    "Dragon's",
    "Dragon",
    "Black",
    "Killswitch",
    "Happy"
}

names.suffixes = {
    "Dude",
    "Man",
    "Ball",
    "Night",
    "Day",
    "Flame",
    "Heat",
    "Dragon",
    "Death",
    "Bane",
    "Goop",
    "Evening",
    "Sway",
    "Door",
    "Water",
    "32",
    "64",
    "99",
    "01",
    "Zero-1",
    "8",
    "Joy",
    "Trigger",
    "Gun",
    "Strength",
    "Weakness"
}

local allNames = {}

local function getSpace()
    if math.random()>.7 then
        return ""
    else
        return " "
    end
end

for x, i in ipairs(names.prefixes) do
    for xx, ii in ipairs(names.suffixes) do
        allNames[#allNames+1] = string.format("%s%s%s",i,getSpace(),ii)
        if (math.random()>.8) then
            allNames[#allNames] = string.format("%s%s",allNames[#allNames], lume.choice(names.suffixes))
        end
    end
end

return allNames