local tutorial = {
    start = "v1",
    v1 = {
[[Welcome, dust gopher, to the underground world of DBB. That stands for
Digging Being Boss, that's me your shadow.]],
"v2"},

    v2 = { 
[[Just kidding about the name, but I'm still your shadow. In each of us lies the instinct 
of battle, and I'm yours. Just listen to me and you'll be kicking up dust motes in no time!
]],
"v3"},

    v3 = {
[[First off you need your special Dust Gun to be able to Dominate the Battle...]],
"v4"},

    v4 = {
[[This your Dust Gun can handle different types of bullets.]],
"v5"},

    v5 = {
[[You can switch out which bullet you wnat to uses by tapping on the bullet's icon on
the Bullet Display at the top left]],
"v6"},

    v6 = {
[[You can collect bullets from crates with a red B by shooting it and collecting its goods,
give it a try.]],
"v7"},

    v7 = {
function(self,map)
    local tile = map:getTile(map.player.tile.x-3,map.player.tile.y-3)
    tile:destroy(true)
    self.crate = map:spawnCrate(bullets.Bullet,1,tile.uuid)
end,
jil,
function(self,map)
    if not self.mini and self.crate.life <=0 then
        self.mini = lume.randomchoice(self.crate.minis)
    end
    if self.mini then
        if not self.mini.active then
            map.tutorial:doNextAction(true)
        end
    end
end},
    v8 = {
[[You collected the bullet automatically...]],
"v9"},
    v9 = {
[[But when you have 3 bullets you have to switch by tapping on the bullet you want to remove.]],
"v10"},
    v10 = {}
}


return tutorial