local Game = {
    playerColors={}
}
function yu(result)
love.window.showMessageBox( "problem" , result, "warning" ,
true ) end-- yu('gettisburg is not a punk, bro')
function Game:log(l)
    log(l)
end

function Game:quit()
    love.event.quit()
end

function Game:enter()
    self.__init__()
end

function Game:getColor(color,a)
    local col =  self.color[color]
    if not col then
        return error(string.format("color %s not found!",color))--self.color.black
    end
    if a then
        col = {col[1],col[2],col[3]}
        col[4] = a
    end
    return col
end

function Game:reset()
    resetAll()
end

function Game:close()
    love.event.quit()
end

function Game:startTraining()
    self:startNewGame()
end

local getChild = function(t,index)
    return t.sons[index].ref
end

function Game:start()
    local scene = Scene:new()
    self.splash = Splash:new()
    mainMenu:init()
    local splash = self.splash
    GSS(splash)
    
    local logo    = self:getSource("logo.png")
    local lw, lh  = logo:getDimensions()
    local company = self:getSource("company.png")
    local cw,ch   = company:getDimensions()
    
    splash:addSplash(logo   , 1, nil, resizeImage(logo,   (W()/_W)*lw, (H()/_H)*lh))
    splash:addSplash(company, 1, nil, resizeImage(company,(W()/_W)*cw, (H()/_H)*ch))
    
    splash:onComplete(function()
        GSS(scene)
    end)
  --GSS(mainMenu)
    
end

function Game:pause()
end

function Game:update(dt)
end

function Game:new(o)
    local o = o or {}
    setmetatable(o, self)
    self.__index = self
    return o
end

function Game:startSavedGame()
end

function Game:startNewGame(map, replay)
    mainMenu:destroy()
    
    media.setVolume(self.settings.music)
    media.setSFXVolume(self.settings.sfx)
    
    if self.currentMenu then
        self.currentMenu:destroy()
    end
    
    if replay then
        mainMenu:create()

        if self.host then
            for x = 1,MAX_PLAYERS do
                mainMenu.waitButtons[x]:setText("...")
            end
            if self.map.host then
                self.map.host:destroy()
                self.players = {}
                self:waitForPlayers()
            else
                self.map.client:disconnectNow()
                self.players = {}
                self:waitForHost()
            end
            mainMenu.current = "wait"
            if self.map then
                self.map:destroy()
            end
            GSS(mainMenu)
            return
        end
    end
    
    log("starting game with "..#self.players) De=.1
    --current Limit checked: 200*2000
    self.currentMap = map or self.map or Underground:new({w = 50,h = 50,
        rules = mainMenu.rules,genRdange=10})
    self.map = self.currentMap

    if not self.player then
        self.player = Player:new({map=self.currentMap})
        self.players[1] = self.player
    end

    if self.player then
        self.player.real = true
        gooi.addComponent(self.player.displayBlocks)
        gooi.addComponent(self.player.displayBullets)
        if not self.currentMap:hasPeer() then
        --    self.players[1] = self.player
        end
    end
    
    
    --??
    self.map.match = mainMenu.match
    self.map:setMatchTime(mainMenu.time)
    self.map.fogOfWar = mainMenu.fogOfWar
    self.map.size = mainMenu.mapSize
    self.map.stealthInspection = mainMenu.stealthInspection
    self.map.mapType = mainMenu.mapType
    self.map.training = mainMenu.training
    mainMenu.training = false
    
  --  self.map.camera:setFollowStyle("SCREEN-BY-SCREEN")
    pp = function()
        self.map.camera:setFollowStyle("PLATFORMER")
    end
    tt = function()
        self.map.camera:setFollowStyle("TOPDOWN")
    end
    ss = function()
        self.map.camera:setFollowStyle("SCREEN-BY-SCREEN")
    end
    
    
    local start = function()
        self.map:start()

        if self.host then
            self.map.pause = 1
        end
        if (self.map.training) then
            for x=1,mainMenu.bots do
                local bot = self.map:spawnBot()
                botdata = getBotData(newBotName())
                bot:reload(
                    botdata[1],
                    botdata[2],
                    botdata[3],
                    botdata[4],
                    botdata[5],
                    botdata[6],
                    botdata[7],
                    botdata[9]
                )
                bot.isCalm = botdata[10]
                    
            end
        end
    end
    
    if not doDebug then
        self.co = coroutine.create(start)
    else
        start()
    end
    
    if self.co then
        coroutine.resume(self.co)
    end
    --love.thread.getChannel("game"):push({function() self.map.start() end})
    --self.thread = love.thread.newThread("data/start.lua")
    --self.thread:start(self)
    

end

function Game:hasSavedGame()
end

function Game:waitForPlayers(isClient)
    if not isClient then
        
        local host, hostPlayer,map
        
        local sendAllPlayers = function(client)
            local p,stats
            for x = 1,MAX_PLAYERS do
                p = self.players[x]
                if p then log("sending "..x) end
                if p then--and (x-1)~= client:getIndex() then
                    stats = {
                        p.source,
                        p.handSource,
                        p.name,
                        p.color,
                        p._hat,
                        p._hat2,
                      --  kz
                        p._hatCol,
                        p._hat2Col,
                        p.uuid,
                        x
                    }
                    client:send("newPlayer",stats)
                    log("sending "..client:getIndex())
                else
                    log("skipped "..x)
                end
            end
        end
        local getClientSource = function(data,client)
            local i = client:getIndex()+1
            local child = getChild(mainMenu.waiting,i)
            --data[9] = lume.uuid()
            log("players are "..#self.players.." at server side")
            sendAllPlayers(client)
            self.players[i] = Player:new({
                client = client,
                map = map,
                x = (child.x+child.w/2)-hostPlayer.w/2,
                y = (child.y+child.h/2)-hostPlayer.h/2,
                source = data[1],
                handSource = data[2],
                name = data[3],
                data = data,
                index = i,
                uuid = data[9]
            })
            
            self.players[i]:reload(data[3],data[4],data[5],data[6],data[7],data[8])
            self.players[i].cindex = client:getIndex()
            self.players[i]._renew_count = 0

            log(" players now at len "..#self.players)
            data[4] = i
            mainMenu.waitButtons[i]:setText(data[3])
            data[10] = i
            client:send("getIndex",{i})
            host:sendToAllBut(client,"newPlayer",data)--??remove maybe
        end
        
        local loadClient = function(data, client)
            -- tell the peer what their index is
            self._players = (self._players or 1)+1
            client:send("getMySource",{self.map.seed,lume.uuid(),self._players})
            client:send("gameType",{
                mainMenu.match, mainMenu.time, 
                mainMenu.fogOfWar, mainMenu.bulletType,
                mainMenu.mapSize, mainMenu.mapType,
                })
        end
        
        local function disconnect(data, client)
        end
            
        local function getMessage(data, client)
            self.map:sendMessage(data[1],data[2],true)
            host:sendToAllBut(client, "getMessage", data)
        end
        
        local function doStuff(data, client)
            local tosend = true
            if data[6] == "map" then
                self.map[data[1]](self.map,data[2],data[3],data[4],data[5])
            else
                data[6] = data[6] or client:getIndex()+1
                if data[1] == "changeVelocityByKeys" or data[6] == "jump" then
                    tosend = false
                    self.map.pause = false
                    --return
                end
                if data[6] == 1 then
                    --should never happen
                    log("Problem?")
                    return
                end
                
                self.player[data[1]](self.players[data[6]],data[2], data[3], data[4], data[5])
                --client controls do not respond
                log(data[6].." player did "..data[1])
            end
            
            if tosend then
                host:sendToAllBut(client, "do", data)
            end
        end
        
        map = Underground:new({w=200,h=200,rules=mainMenu.rules})
        self.map = map
        
        local i = 1
        local child = getChild(mainMenu.waiting,i)
        
        self.activate = 1
        
        host = sock.newServer("*", 22122, MAX_PLAYERS-1)
        host:setSerialization(bitser.dumps, bitser.loads)
        host._destroy = host.destroy
        function host:destroy(...)
            for _, cl in ipairs(self.clients) do
                cl:disconnectNow()
            end
            self:update(0)
            self:_destroy(...)
            mainMenu.peer = nil
            game.host = nil
            game.player.host = nil
        end
        
        hostPlayer = Player:new({
            map = map,
            host = host,
            x = (child.x+child.w/2)-16/2,
            y = (child.y+child.h/2)-16/2,
        })
        self.player = hostPlayer
        self.players[1] = hostPlayer
        mainMenu.waitButtons[1]:setText(self.player.name)
        --mainMenu.waitButtons[1]:setSource(self.player.icon")
        
        local function destroyTile(data)
            local t = self.map:getTile(data[1],data[2])
            t = t and t:destroy(data[3])
        end
        
        local function resume()
            self.activate = self.activate+1
        end
        
        local function doRespawn(data)
            map:doRespawn(data)
        end
        
        local function requestTurretSpawn(data)
            local t = Turret:new({map=self.map or map, x=data[1], y=data[2], bullet=data[3],
            parent={team=data[4]}})
        end
        
        local function updateCrate(data)
            local cr = self.map.crates[data[1]]
            if not cr then warn("no crate "..data[1]) return end
            cr.life = data[2]
            cr.x = data[3]
            cr.y = data[4]
        end
        
        local function renewClient(data,client)
            local pl = self.players[tonumber(data)]
            pl._renew_count = getUpdateCount()
        end
        
        function setPlayerStats(data,client)
            local pl = self.players[client:getIndex()+1]
            pl.stats = data
            self.map._canEndGame = (self.map._canEndGame or 1) + 1
            if self.map._canEndGame >= #self.players then
                self.map.canEndGame = true
            end
            warn(self.map.canEndGame) warn(self.map._canEndGame) warn(#self.players)
        end
        er = function() self:endGame() end
        host:on("connect",loadClient)
        host:on("mySource",getClientSource)
        host:on("sendMessage",getMessage)
        host:on("do",doStuff)
        host:on("ready",resume)
        host:on("hostDestroyTile",destroyTile)
        host:on("requestRespawn", doRespawn)
        host:on("requestTurretSpawn",requestTurretSpawn)
        host:on("updateCrate",updateCrate)
        host:on("renewClient",renewClient)
        host:on("setPlayerStats",setPlayerStats)
        --remove--???
        host:on("color", function()
            self.map.player.color = lume.randomchoice(colors)
        end)
        function host:sendMessage(mes,color)
            self:sendToAll("getMessage",{mes,color})
        end
        
        local schema = {"uuid","class","x","y","w","h","angle","source","life","parent"}
        host:setSchema("newEntityCreated",schema)
        self.host = host
        
        map.isHost = true
        map.host = host
        mainMenu.peer = host
        map.player = hostPlayer
        self.map = map--????
        
        
    end
    --???popUp?
end

function Game:waitForHost()
    log('really start'..#self.players)
    local client, hostPlayer, map
    local function connect(data)
        log("connected")
        log(#self.players)
        mainMenu.current = "wait"
    end
    
    local function sendSource(data)
        
        local i = data[3]--client:getIndex()
        log("pl after cl"..#self.players) log(inspect(data))
        local child = getChild(mainMenu.waiting,i)
        
        map = Underground:new({seed=data[1],w=200,h=200,rules=mainMenu.rules})
        self.map = map
        self.map.pause = true
        map.isClient = true
        map.client = client
        log(tostring(map.client))
        log("pl after m"..#self.players)
        self.player = Player:new({
            map = map,
            client = client,
            x = (child.x+child.w/2)-16/2,
            y = (child.y+child.h/2)-16/2,name="Xshiwer32",
            uuid = data[2]
        })
        hostPlayer = self.player
        log(#self.players)
        mainMenu.waitButtons[i]:setText(self.player.name)
        log(#self.players)
        self:waitForPlayers(true)
        log("inserting player "..i.." at len "..#self.players)
        --self.players[i] = self.player
        log(" players now at len "..#self.players)
        self.player.index = i
        self.player.cindex = client:getIndex()
        
        client:send("mySource",{
            self.player.source,
            self.player.handSource,
            self.player.name,
            self.player.color,
            game.settings.hat,
            game.settings.hat2,
            game.settings.hatColor,
            game.settings.hat2Color,
            self.player.uuid})
    end
    
    local function getNewPlayer(data)
        log("staritng"..#self.players)
        local i = data[10]--fix???!!!
        log("player name is "..data[3])
        if data[9] == self.player.uuid then
            log("got it already!")
            self.players[i]  = self.player
            return
        end
        log("recording "..i.." player! should show once")
        log("player name is "..data[3])
        local child = getChild(mainMenu.waiting,i)
        self.players[i] = Player:new({
            client = i,
            map = map,
            x = (child.x+child.w/2)-hostPlayer.w/2,
            y = (child.y+child.h/2)-hostPlayer.h/2,
            source = data[1],
            handSource = data[2],
            name = data[3],
            index = i,
            color = data[4],
            uuid = data[9]
            })
        self.players[i]:reload(data[3],data[4],data[5],data[6],data[7],data[8])
        
        log(" players now at len "..#self.players)
        mainMenu.waitButtons[i]:setText(self.players[i].name)
    end
    
    local function disconnect(data)
        --destroy some peer maybe
        if self.map then
            self.map:destroy()
        end
        log("gone")
        GSS(mainMenu)
        mainMenu:create("menu")
        gooi.alert({text="You have been disconnected!"})
    end
    
    local function doStuff(data)
    log("do"..inspect(data))
        if data[6] == "map" then
            self.map[data[1]](self.map,data[2],data[3],data[4],data[5])
        else
            if data[1] == "changeVelocityByKeys" or data[1] == "jump" then
                --return
            end
            if self.players[data[6]]==self.player then
                return
            end
            data[6] = data[6] or self.player.index
            self.player[data[1]](self.players[data[6]],data[2], data[3], data[4], data[5])
        end
    end
        
    local function startMatch(data)
        --client.pause = 1
        log("THERE ARE "..#self.players.." CONNECTED!")
        log("uuid of player 1: "..self.players[1].uuid)
        log("uuid of player 2: "..self.players[2].uuid)
        game:startNewGame()
        self.map.pause = nil--??? 
        log("started Match")
    end
    
    local function activate()
        if self.map.pause then
          --  self.map.client:send("ready")
        end
        if self.map.pause then
            self.map:update(0)
        end
        self.map.pause = false log('upp un paused')
    end
    
    local function destroyTile(data)
        log("destroying tile")
        local t = self.map:getTile(data[1],data[2])
        local t = t and t:destroy(data[3],true)
    end
    
    local function spawnPlayer(data)
    log("spppppp")
        --self.map.pause = false
        self.map:spawnPlayer(data[1],data[2],data[3])
    end
    
    local function getMessage(data)
        self.map:sendMessage(data[1],data[2],true)
    end
    
    local function setGameType(data)
        mainMenu.match = data[1]
        mainMenu.time = data[2]
        mainMenu.fogOfWar = data[3]
        mainMenu.bulletType = data[4]
        mainMenu.mapSize = data[5]
        mainMenu.mapType = data[6]
    end
    
    local function spawnTurret(data)
        local t = Turret:new({map=self.map or map, x=data[1], y=data[2], bullet=data[3]})
        self.map.turrets[data[4]] = t
        t.parent = {team=data[5]}
    end
    
    local function updateTurret(data)
        local t = self.map.turrets[data[1]]
        if not t then warn("No turret! at "..data[1]) else
        t.life = data[2] end
    end
    
    local function destroyCrate(data)
        local cr = self.map.crates[data]
        if not cr then
            warn("No to destroy crate "..data)
        else
            cr:destroy(1)
        end
    end
    
    local function updateCrate(data)
        local cr = self.map.crates[data[1]]
        if not cr then warn("no crate "..data[1]) return end
        cr.life = data[2]
        cr.x = data[3]
        cr.y = data[4]
        cr:moveTo(cr.x, cr.y)
    end
    
    local function getIndex(data)
        self.player.index = data[1]
        game.players[data[1]] = self.player
        log("got index as "..data[1])
    end
    
    local done,err = pcall(function() client = sock.newClient("255.255.255.255", GAME_PORT) end)
    if not done then
        mainMenu.current = "locall"
        gooi.palert({text=err or "Failed?"})
    end
    client._update = client.update
    --???!!!--
    if not doDebug then
    
    function client:update(...)
        local done,err = pcall(self._update,self)
        if not done then
            mainMenu.current = "locall"
            gooi.alert({text=err or "Failed?"})
            if self.map then
                self.map:destroy()
                mainMenu.create()
                GSS(mainMenu)
            end
            mainMenu.peer = nil
        end
    end
    
    end
    
    
    client:on("connect",connect)
    client:on("disconnect",disconnect)
    client:on("getMySource",sendSource)
    client:on("newPlayer",getNewPlayer)
    client:on("do", doStuff)
    client:on("startMatch",startMatch)
    client:on("destroyTile",destroyTile)
    client:on("spawnPlayer",spawnPlayer)
    client:on("getMessage",getMessage)
    client:on("gameType",setGameType)
    client:on("activate",activate)
    client:on("spawnTurret",spawnTurret)
    client:on("updateTurret",updateTurret)
    client:on("destroyCrate",destroyCrate)
    client:on("updateCrate",updateCrate)
    client:on("getIndex",getIndex)
    
    --remove--???
    client:on("color", function()
        self.map.player.color = lume.randomchoice(colors)
    end)
    
    function client:sendMessage(mes,color)
        self:send("sendMessage",{mes,color})
    end
    
    client:setSerialization(bitser.dumps, bitser.loads)
    
    local schema = {"uuid","class","x","y","w","h","angle","source","life","parent"}
    client:setSchema("createNewEntity",schema)
    client:setSchema("updateEntity",schema)
    mainMenu.peer = client
    
    client:connect()
end
    
function Game:__init__(debug,kwargs)
    local kwargs = kwargs or {}
    
    self._sources = {}
    self._storage = {}
    self.players = {}
    
    self.settings = self.loadSettings() or {
        music = kwargs.music or 5,
        sfx = kwargs.sfx or 5,
        name = kwargs.name or "Player",
        color = kwargs.color or "chocolate",
        hat = kwargs.hat or "TopHat",
        hat2 = kwargs.hat2 or "None",
        stomachColor = kwargs.stomachColor or "white",
        gunColor = kwargs.gunColor or "white",
        
        playerSource = kwargs.playerSource or "players/gopher.png",
        handSource = kwargs.handSource or "players/hands.png",
        stomachSource = kwargs.stomachSource or "players/stomach.png",
        gunSource = kwargs.gunSource or "players/gun.png",
        
        mouse_shoots = true,
        
        gore = 2,
        firstTime = true
    }
    
    if not DESKTOP then
        game.settings.mouse_shoots = false
    end
    
    if game.settings.keys then
        IM.KEYMAP = game.settings.keys
    end

    self.debugInfo = debug or true
    self.debug = debug or true
    self.debugLabel = 
     gooi.newLabel({text = "Debugger", x = 50, y = 185, w = 70, h = 10}):left()
    self.color = color
    
    self.tmp = {}
    self.setText=function(...) self.debugLabel:setText(...) end
    self.progress = ProgressionBar:new({
        x=(W()/2)-((W()/1.5)/2),
        y = H()-(H()/10)*2,
        h = H()/10,
        w = W()/1.5
    })
    
    self.forceDraw = function()
        love.graphics.present()
        love.graphics.clear()
    end
    
    --data--
    self.userName = "Newbie"
    self._color = "brown"
    
    self:loadEmotions()
end

nn=nil rT=j54
local sourcie = "assets/%s"
function Game:getSource(source, new)--[[
if not nn then nn=love.graphics.newImage("assets/none.png") end
if rT then return nn end]]
    if self._sources[source] == nil or new==true then
        self._sources[source] = Graphics.newImage(string.format(sourcie,source))--scale later
    end
    return self._sources[source]
end

function Game:getAsset(...)
    return self:getSource(...)
end

function Game:saveSettings()
    getSettingsToSave():write(saveTable(self.settings))
end

function Game:loadSettings()
    return getSettingsToLoad()
end

function Game:getPassivePlayer(x,y,w,h)
    map = Underground:new({seed=data,w=200,h=200,rules=mainMenu.rules})
    local player = Player:new({
        map = map,
        x = x or 0,
        y = y or 0,
        h = h or 0,
        w = w or 0,
        passive = true
    })
    return player
end

function Game:loadEmotions()
    self.emotionImages, self.emotionSprites, self.emotions = self:getEmotions()
end

function Game:getEmotionSprite(e)
    local sprite = self.emotionImages[e]
    return animx.newActor():
        addAnimation("walking",{
            img = sprite,
            tileWidth = 40*res,
            delay = .2
        }):
        addAnimation("running",{
            img = sprite,
            tileWidth = 40*res,
            delay = .1
        }):
        addAnimation("standing",{
            img = sprite,
            tileWidth = 40*res,
            noOfFrames = 1
        }):
        addAnimation("jumping",{
            img = sprite,
            tileWidth = 40*res,
            noOfFrames = 1,
            x = 41*res
        }):loopAll():switch("standing")
end

function Game:getEmotions()
    local emotions = {
        happy = "happy_gopher.png",
        happysad = "happysad_gopher.png",
        angry = "angry_gopher.png",
        cocky ="cocky_gopher.png",
        whimpering = "whimpering_gopher.png",
        sad = "sad_gopher.png",
        normal = "gopher.png",
        discomforted = "discomforted_gopher.png"
    }
    local sprites = {}
    local _emotions = {}
    
    for x, i in pairs(emotions) do
        emotions[x] = game:getAsset(string.format("players/%s",i))
        _emotions[#_emotions+1] = x
        
        local sprite = emotions[x]
        
        sprites[x] = animx.newActor():
        addAnimation("walking",{
            img = sprite,
            tileWidth = 40*res,
            delay = .2
        }):
        addAnimation("running",{
            img = sprite,
            tileWidth = 40*res,
            delay = .1
        }):
        addAnimation("standing",{
            img = sprite,
            tileWidth = 40*res,
            noOfFrames = 1
        }):
        addAnimation("jumping",{
            img = sprite,
            tileWidth = 40*res,
            noOfFrames = 1,
            x = 41*res
        }):loopAll():switch("standing")
    end
    return emotions, sprites, _emotions
end

function Game:reset()
end


function Game:draw()
end

function Game:released(x, y, button) gooi.released(x,y,button) end
function Game:pressed(x, y, button)  gooi.pressed(x,y,button) end

function Game:touchreleased(id, x, y, dx, dy, pressure)
    if not self.buttonPressed then
        ttx = x
        tty = y
    end
    self.buttonPressed = false
end

function Game:textinput(text)
  gooi.textinput(text)
end

function Game:keypressed(key, scancode, isrepeat)
  gooi.keypressed(key, scancode, isrepeat)
  if key == "escape" then
    p:close()
    love.event.quit()
  end
end

function Game:keyreleased(key, scancode) log(key) log("kr")
  gooi.keyreleased(key, scancode)
end

function Game:getData(data,actor,skip)

    if type(data) ~= "table" then
        return self:getActor(data,actor)
    end
    
    if data[1] == "get" then
        local val,_name,_val,op,get2
        _name = data[2]
        _val = data[3]
        op = data[4]
        get2 = data[5]
        local item = self:getActor(_name,actor)
        if OPERATORS[_val] then
            if type(_name) == "table" then
                _name = self:getData(_name,actor)
            end
            get2 = op
            op = _val
            val = _name
        else
            val = item[_val]
        end
        if op then
            local g2 = get2
            if type(g2) == "table" then
                g2 = getData(get2,actor)
            end
            val = operate(val,op,g2)
        end
        return val
    else
        if not skip then
            for _,i in ipairs(data) do
                if type(i) == table then
                    data[_] = self:getData(i,actor,true)
                end
            end
            for _,i in pairs(data) do--????
                if type(i) == table then
                    data[_] = self:getData(i,actor,true)
                end
            end
        end
        return data
    end
end

function Game:loadDungeon(unit,tile)
    u={}
    for x=1,9 do table.insert(u,Unit:new()) end
    local d = Dungeon:new({
        data=allCreatures[tile.creature].dungeon,
        units=u,
        player=bover.camp})
    GSS(d)
end

--stores an object by its id
function Game:store(object)
    --self._storage[tostring(object)] = object
end

--gets an object by its id
function Game:get(object) if 1 then return error() end
    local id = (type(object) ~= "table" and object) or tostring(object)
    local obj = self._storage[id]
    if not obj then
        warn("Object "..tostring(object).." of type "..type(object).." not found")
        return false
    end
    return obj
end

function Game:loadLua(code,actor)
    --Abusing löve2d to load lua code from files.
    --There may be a better way to do this, but wateves...
    local tmpLua = love.filesystem.newFile("tmpLua.lua","w")
    tmpLua:write(code)
    tmpLua:close()
    local func = love.filesystem.load("tmpLua.lua")
    self.actor = actor
    return func()
end

function Game:getActor(id,actor)
    if actor then
        if id == "self" then
            return actor
        end
    end
    if id == "game" then
        return self
    elseif id == "user" then
        return self.tmp.user
    elseif id == "target" then
        return self.tmp.user and self.tmp.user.target
    elseif id == "map" then
        return self.map
    end
    
end

function Game:decodeScript(script,user,obj)

    --actor will be the one whose values gets changed
    --self is the object the script belongs to
    
    local _obj = obj
    local _if = lume.copy(script._if)
    local obj = obj or script
    
    local actor = self:getActor(script.actor,obj)
    
    self.tmp.user = user
    self.tmp.obj = obj
    self,tmp.actor = actor
    
    if type(_if) == "table" then
        _if = self:getData(_if, obj)
    end
    if not _if then
        return false
    end
    
    for name, data in ipairs(script) do
        if name == "_if" then
            goto continue
        end
        if type(data) == "table" then
            data = self:getData(data,obj)
            if type(data[1]) == "string" then
                local loc = data[1]
                if self.positions[loc] then
                    local pos = self.positions[loc]
                    pos.x = pos.x+data[2]
                    pos.y = pos.y+data[3]
                end
            end
        end
        if name == "anim" then
            local anim = self:loadLua(data,actor)
            anim:start()
        elseif name == "wait" then
            scriptIsBusy = scriptIsBusy+data
        elseif name == "decode" then
             for _,x in lume.iter(data) do 
                self:decodeScript(x, user, _obj)
            end
        elseif name == "goal" then
            actor:moveTo(data)
        elseif name == "acts" then
            for _,code in pairs(data) do
                self:loadLua(code,actor)
            end
        elseif name == "attackBehaviour" then
            actor.battle = self.attackBehaviours[data] or self:loadLua(actor,data)
        elseif name == "attacks" then
            for attack,val in lume.iter(data) do
                actor.attacks[attack] = self.attacks[attack] or self:loadLua(actor,val)
            end
        end
        actor[name] = data
        ::continue::
    end
    --Just because
    return actor
end

return Game