local hats = {}
local Hat = Hat

hats.TopHat = Hat
function hats.TopHat.getImage(hat)
    return hats[hat].source
end

--[[None]]--
hats.None = Hat:extend("None")
function hats.None:__init__(kwargs)
    local kwargs = kwargs or {}
    kwargs.source = "none.png"
    Hat.__init__(self,kwargs)
end

--[[Witch Hat]]--
hats.WitchHat = Hat:extend("WitchHat")
function hats.WitchHat:__init__(kwargs)
    kwargs.source = "hats/witchHat.png"
    Hat.__init__(self,kwargs)
    self._baseH = self.h
    self._baseW = self.w
    self:calculate()
end

--[[Posh Glasses]]--
hats.PoshGlasses = Hat:extend("PoshGlasses")
function hats.PoshGlasses:__init__(kwargs)
    kwargs.source = "hats/poshGlasses2.png"
    Hat.__init__(self,kwargs)
end

--[Hockey Mask]]--
hats.HockeyMask = Hat:extend("PoshGlasses")
function hats.HockeyMask:__init__(kwargs)
    kwargs.source = "hats/hockeyMask.png"
    kwargs.color = "white"
    Hat.__init__(self,kwargs)
end

--[Obito Mask]]--
hats.ObitoMask = Hat:extend("ObitoMask")
function hats.ObitoMask:__init__(kwargs)
    kwargs.source = "hats/obitoMask.png"
    kwargs.color = "orange"
    Hat.__init__(self,kwargs)
end

--[Scary Mask]]--
hats.ScaryMask = Hat:extend("ScaryMask")
function hats.ScaryMask:__init__(kwargs)
    kwargs.source = "hats/scaryMask.png"
    kwargs.color = "white"
    Hat.__init__(self,kwargs)
end

--[Cyborg Mask]]--
hats.CyborgMask = Hat:extend("CyborgMask")
function hats.CyborgMask:__init__(kwargs)
    kwargs.source = "hats/cyborgMask.png"
    kwargs.color = "white"
    Hat.__init__(self,kwargs)
end

--[Mole(?) Mask]]--
hats.MoleMask = Hat:extend("MoleMask")
function hats.MoleMask:__init__(kwargs)
    kwargs.source = "hats/moleMask.png"
    kwargs.color = "orange"
    Hat.__init__(self,kwargs)
end

for x, i in pairs(hats) do
    i._name = x
end

return hats