local Weapon = class:extend("Weapon")

function Weapon:__init__()
    self.bulletCount = 20      -- initialize our object
    self.weaponChargingRate=0.02
    self.weaponSpeed=30
    self.weaponImpact=10
    self.weaponPenetration=10
end

function Weapon:getBulletCount()
	return self.bulletCount
end

function Weapon:setBulletCount(bulletCount)
	self.bulletCount=bulletCount
end

function Weapon:getWeaponChargingRate()
	return self.weaponChargingRate
end

function Weapon:setWeaponChargingRate(rate)
	self.weaponChargingRate=rate
end

function Weapon:setWeaponImpact(impact)
	self.weaponImpact=impact
end

function Weapon:getWeaponImpact()
	return self.weaponImpact
end

function Weapon:setWeaponPenetration(penetration)
	self.weaponPenetration=penetration
end

function Weapon:getWeaponPenetration()
	return self.weaponPenetration
end

function Weapon:hasBullets()
	if self.bulletCount > 0 then
		return 1
	else
		return 0
	end
end

function Weapon:setMaxBulletCount(bulletCount)
	self.bulletCount=bulletCount
end

function Weapon:setWeaponSpeed(speed)
	self.weaponSpeed=speed
end

function Weapon:getWeaponSpeed()
	return self.weaponSpeed
end

return Weapon
