--[[local function getTime()
    return os.time()
end
function table.insert(t,v)
    t[#t+1] = v
end
local test = {}
local x,y = 4, 5
local p = {x,y}
local s = getTime()

table.insert(test,p)
local ss = os.difftime(s)

error("That took "..ss.." to complete")]]
--[[_g = {}
for u,i in pairs(_G) do _g[u] = i end
nextC=0
function changeC()
    self.player.color=colorList[nextC]
    nextC=nextC+1
    log(self.player.color)
end


colorList = { "tan", "steelblue", "ghostwhite",
"sandybrown", "mistyrose", "antiquewhite", "bisque", "firebrick",
"gainsboro", "cornflowerblue", "oldlace", "orange", "lightpink", 
"gold", "darkolivegreen", "aliceblue", "blueviolet", "gray", "dimgrey",
"aqua", "powderblue", "dodgerblue", "olive", "midnightblue", "snow",
"navy", "yellowgreen", "moccasin", "crimson", "deeppink", "lightblue",
"darkorange", "darkturquoise", "darkblue", "grey", "indigo", "lightgray",
"honeydew", "lightsalmon", "indianred", "thistle", "darkred", "coral",
"skyblue", "darkseagreen", "blue", "lavender", "lightgreen", "red",
"goldenrod", "yellow", "slateblue", "mediumaquamarine", "rosybrown",
"cyan", "darkgoldenrod", "darkgray", "violet", "white", "wheat", "maroon",
"forestgreen", "limegreen", "mediumblue", "mediumspringgreen", "blanchedalmond",
"peru", "mediumturquoise", "slategray", "lightcoral", "magenta", "turquoise",
"darkslateblue", "palevioletred", "sienna", "lightslategray", "mediumpurple",
"silver", "ivory", "royalblue", "lightyellow", "palegoldenrod", "chartreuse",
"lemonchiffon", "cornsilk", "saddlebrown", "orangered", "lavenderblush",
"tomato", "papayawhip", "chocolate", "khaki", "pink", "greenyellow",
"navajowhite", "teal", "darkorchid", "darkgrey", "darksalmon", "deepskyblue",
"darkcyan", "mediumslateblue", "darkslategray", "hotpink", "darkviolet",
"brown", "plum", "aquamarine", "lightgoldenrodyellow", "slategrey",
"lightsteelblue", "mintcream", "lightcyan", "lime", "mediumvioletred",
"seagreen", "mediumseagreen", "salmon", "lightslategrey", "dimgray",
"beige", "darkgreen", "lightgrey", "green", "palegreen", "seashell",
"paleturquoise", "darkmagenta", "black", "olivedrab", "darkkhaki", "purple",
"burlywood", "mediumorchid", "linen", "cadetblue", "peachpuff", "darkslategrey",
"lawngreen", "lightskyblue", "springgreen", "floralwhite", "azure", "whitesmoke",
"orchid", "fuchsia" }
]]

love._run = love.run


love.oldmyrun = function()
    local n = love._run()
    local nn = function()
    if ggy then log("!!!!!%") ddef=3
        ProFi:start()
    end n() --assert(not ggy)
    if ggy and ddef then
        ProFi:stop()
        ProFi:writeReport("urun.txt")
        ggy = nil log("!??*")
    end end return nn
    
end


function love.ruyn()
	if love.load then love.load(love.arg.parseGameArguments(arg), arg) end

	-- We don't want the first frame's dt to include time taken by love.load.
	if love.timer then love.timer.step() end

	local dt = 0

	-- Main loop time.
	return function()
		-- Process events.
		if love.event then
			love.event.pump()
			for name, a,b,c,d,e,f in love.event.poll() do
				if name == "quit" then
					if not love.quit or not love.quit() then
						return a or 0
					end
				end
				love.handlers[name](a,b,c,d,e,f)
			end
		end

		-- Update dt, as we'll be passing it to update
		if love.timer then dt = love.timer.step() end

		-- Call update and draw
		if love.update then love.update(dt) end -- will pass 0 if love.timer is disabled

		if love.graphics and love.graphics.isActive() then
			love.graphics.origin()
			love.graphics.clear(love.graphics.getBackgroundColor())

			if love.draw then love.draw(dt) end

			love.graphics.present()
		end

		--commenting it out makes game faster?
		--if love.timer then love.timer.sleep(0.001) end
	end

end

ty=function() for r=1,14 do game.map:spawnCrate() end end
--pcall(command) = bool completed, error msg or return
function love.load()
    
    MAX_PLAYERS = 9
    MAP_SEED = love.timer.getTime()
    OS = love.system.getOS()
    DESKTOP = OS ~= "Android" and OS ~= "IOS"
    
    OBJECT_POOLING = false
    doDebug = false--false
    returnTick = 1--don't return prematurely in update
    res = 4 --resolution for player sprite
    
    RECORDS = {
        updateCount = 0
    }
    getUpdateCount = function()
        return RECORDS.updateCount
    end
    
    rc = function(c) reloadClass(c) end
    
    loadLuaCode = _G.load
    
    --class
    class = require 'tools/class'


    --home brewed helper functions
    require 'tools/tools'
    print = log



    font13 = love.graphics.newFont(H(30))
    font8 = love.graphics.newFont(H(20))
    
    --font13 = love.graphics.newFont(love.window.toPixels(H(20)))
    --font8 = love.graphics.newFont(love.window.toPixels(H(15)))
    
    --home brewed helper classes
    local bars = require_and_sign 'tools/bars'
    LifeBar, ProgressionBar = bars[1],bars[2] --require 'tools/bars'


    --gui
    require 'tools/gooi'
    listbox = require_and_sign 'tools/listbox'



    --helper functions/variables
    color = require_and_sign 'tools/color'
    rot = require_and_sign "tools/src.rot"
    lume = require_and_sign 'tools/lume'
    lurker = require_and_sign 'tools/lurker'
    colors = color
    bump = require_and_sign 'tools/bump'
    inspect = require_and_sign 'tools/inspect'
    animx = require_and_sign 'tools/animx'

    --[[r = rot.StringGenerator()
    stuff = {}
    for x,i in ipairs({
        "elf",
        "dragon",
        "drakon",
        "kraken",
        "fairy",
        "dwarf",
        "firefly",
        "stinkfly",
        "rat",
        "locust",
        "crab",
        "goblin",
        "kobold",
        "griffin",
        "hobbit",
        "wyvern",
        "influenza",
        "vulkan",
        "dread",
        "plasma",
        "cholera",
        "slime",
        "zombie",
        "wight",
        "beast",
        "troll",
        "orc",
        "illness",
        "other"
        
    }) do
        stuff[i]=x
    end

    
    for x,i in pairs(stuff) do
        r:observe(x)
    end
    fc=""
    function get(s)
       ss= s:generate()
       if stuff[ss] then
           return get(s)
        end
       return ss
    end
    dr={}
    for x=1,45 do
        dr[x] = get(r)
    end
    error(inspect(dr))]]

    
    randomchoice = lume.randomchoice
    
    --home brewed
    hotswap = require_and_sign 'tools/hotswap'
    hotswap.init()
    
    --styles
    scifiStyle = {
        bgColor = colors.blue,
        borderColor = colors.black,
        showBorder = true
    }
    dustStyle = {
        bgColor ={176/255,122/255,14/255},-- colors.darkbrown,
        borderColor = colors.black,
        showBorder = true
    }
    
    botHeuristic = function(nodeA, nodeB) 
	    local dx = math.abs(nodeA._x - nodeB._x)
	    local dy = math.abs(nodeA._y - nodeB._y)
	    local dis = (dx + dy)
	    local m = game.map if ded then return dis end
	    if m then
	        --local tileA = m:getTile(nodeS._x,node.A._y)
	        local tileB = m:getTile(nodeB._x,nodeB._y)
	        if tileB.isBackground then
	           dis = dis - 5
	       end
	   end
	   return dis
    end

    gooi.desktopMode()
    gooi.setStyle(dustStyle)


    --helper classes and stuff
    ProFi = require_and_sign "tools/ProFi"
    Camera = require_and_sign 'tools/camera'
    Paddy = require_and_sign 'tools/paddy'
    JumperGrid = require_and_sign "tools/jumper.grid"
    PathFinder = require_and_sign "tools/jumper.pathfinder"
    Gamestate = require "tools/hump/gamestate"
    Timer = require_and_sign "tools/hump/timer"
    saveTable = require_and_sign "tools/saveTable"
    splashy = require_and_sign "tools/splashy"
    Andralog = require_and_sign "tools/andralog"
    multisource = require_and_sign "tools/multisource"
    bitser = require_and_sign "tools/bitser"
    sock = require_and_sign "tools/sock"
    Chrono = require_and_sign "tools/chrono"
    Talkies = require_and_sign "tools/talkies"

    --managers
    AudioManager = require_and_sign "managers/audioManager"
    InputManager = require_and_sign "managers/InputManager"
    
    --core stuff
    help = require_and_sign "data/help"
    Game = require_and_sign "game"
    Splash = require_and_sign "splash"
    media = require_and_sign "media"
    online = require_and_sign "online"
    
    IM = InputManager:new()
    input = IM
    inputManager = IM

    game = Game:new()
    game:__init__()
    media.load()
    
    media.setSFXVolume(game.settings.sfx)
    media.setVolume(game.settings.music)
    
    store = function(...) return game:store(...) end

    --ser= require_and_sign "ser"
    --lo=load((ser(player)))()


    --maps
    GridMap = require_and_sign "maps/gridMap"
    Underground = require_and_sign "maps/underground"



    --menus
    infoMenu = require_and_sign "menus/infoMenu"
    HelpMenu = require_and_sign "menus/helpMenu"
    SettingsMenu = require_and_sign "menus/settingsMenu"
    OnlineMenu = require_and_sign "menus/onlineMenu"
    mainMenu = require_and_sign "menus/mainMenu"
    PopUp = require_and_sign "menus/popUp"
    ScoreDisplay = require_and_sign "menus/scoreDisplay"
    AchievementsMenu = require_and_sign "menus/achievementsMenu"


    --base classes
    Entity = require_and_sign "bases/entity"
    Tile = require_and_sign "bases/tile"
    
    
    --entities
    Bullet = require_and_sign "entities/bullet"
    Player = require_and_sign "entities/player"
    Bot = require_and_sign "entities/bot"
    DungeonDigger = require_and_sign "entities/dungeonDigger"
    Turret = require_and_sign "entities/turret"
    Mini = require_and_sign "entities/mini"
    Crate = require_and_sign "entities/crate"
    
    Puff = require_and_sign "entities/puff"
    Debris = require_and_sign "entities/debris"
    Explosion = require_and_sign "entities/explosion"
    
    Spark = require_and_sign "entities/spark"
    
    --Fire = require_and_sign "entities/fire"
    
    Hat = require_and_sign "entities/hat"
    
    
    --data
    playerColors = require_and_sign "data/colors"
    bullets = require_and_sign "data/bullets"
    tiles = require_and_sign "data/tiles"
    hats = require_and_sign "data/hats"
    tutorial = require_and_sign "data/tutorial"
    
    
    if game.settings.firstTime or not game.settings.botNames or not game.settings.botdata then
        local botNames = require_and_sign "data/botNames"
    
        local botNameGen = rot.StringGenerator()
        for x = 1,#botNames do
            botNameGen:observe(botNames[x])
        end
    
        local function contains(tab, name)
            for x = 1,#tab do
                if tab[x] == name then
                    return true
                end
            end
        end
    
        local function newBotName()
            local rand = math.random()
            if (rand<.7) then
                return lume.randomchoice(botNames)
            else
                local name = botNameGen:generate()
                while contains(botNames, name) or string.len(name)>10 do
                    name = botNameGen:generate()
                end
                botNames[#botNames+1] = name
                return name
            end
        end
    
        game.settings.botNames = {}
        game.settings.botdata  = {}
        for x = 1,20 do
            local name = newBotName()
            game.settings.botNames[#game.settings.botNames+1] = name
            game.settings.botdata[name] = {
                    name,
                    lume.randomchoice(playerColors),
                    lume.randomchoice(hats)._name,
                    lume.randomchoice(hats)._name,
                    lume.randomchoice(playerColors),
                    lume.randomchoice(playerColors),
                    lume.randomchoice(playerColors),
                    lume.randomchoice(playerColors),
                    math.random()>.3
            }
        end
        
        game:saveSettings()
    end
    botNames = game.settings.botNames
    
    function newBotName()
        return lume.randomchoice(botNames)
    end
    
    function getBotData(name)
        return game.settings.botdata[name or newBotName()]
    end

    ---
    
    Scene = require_and_sign "scene"
    Config = require_and_sign "config"
    Tutorial = require_and_sign "tutorial"

    DT = 0
    DTmax = .5

    ---Shortcuts for often used functions, variables, etc...---
    Gs = Gamestate
    GS = Gamestate
    GSwitch = Gamestate.switch
    Gss = Gamestate.switch
    GSS = Gamestate.switch
    
    
    ---For switching back to the old state (can also use actual index in class: .oldState)---
    OLD_STATE = nil

    Gamestate.registerEvents()

    game:start()
    
end
