--A wrapper for splashy

 Splash = class:extend("Splash")
 
 function Splash:__init__()
    --self.splashy = splashy (not needed)
    self.camera = Camera()
end

function Splash:update(dt)
    self.camera:update(dt)
    splashy.update(dt)
end

function Splash:draw()
    self.camera:attach()
    splashy.draw()
    self.camera:detach()
   -- self.camera:draw()
end

function Splash:addSplash(...)
    local args = {...}
    self.camera:fade((args[2] or 2)/2,{0,0,0,1})
    splashy.addSplash(...)
end

function Splash:onComplete(func)
    splashy.onComplete(function()
        self.camera:fade(1,{0,0,0,0})
        func()
    end)
end

function Splash:reload()
    splashy.list = {}
    splashy.inalpha = 0
    splashy.outalpha = 255
    splashy.count = 1
    splashy.tweenlist = {}
    splashy.fadestate = "in"
    splashy.finished = false
    splashy.onCompleteFunction = nil
end

function Splash:mousereleased()
    splashy.skipSplash()
end

function Splash:keyreleased()
    splashy.skipSplash()
end

return Splash